#if !defined(AFX_TASKBARTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_)
#define AFX_TASKBARTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef vector<COLORREF> ColorRefList;
typedef vector<COLORREF>::iterator ColorRefListIterator;

class TaskbarTexture  
{
public:
	TaskbarTexture();
	virtual ~TaskbarTexture();

	void configure(const string &name, const bool &transparencyMode);
	void apply(HDC hDC, int x, int y, int width, int height, bool trueTransparency);

	bool isTransparencyNeeded() { return transparencyNeeded; };

private:

	bool useAlphaMap;

	bool transparencyNeeded;
	bool useSolidColors;

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void solidGradientPaint(HDC destHDC, RECT r, bool vertical);
	void paintEffects(HDC destHDC, int width, int height);
	void PrepareAlphaChannel(HBITMAP &bmp);

	HDC memoryDC;
	HBITMAP memoryBitmap;

	ColorRefList Gradient;

	int imageHeight;
	int imageWidth;

	int leftEdge;
	int topEdge;
	int rightEdge;
	int bottomEdge;

	int mode;

	int taskbar_saturation;
	int taskbar_hueIntensity;
	COLORREF taskbar_hueColor;

	int bevelSize;
	bool verticalGradient;
	COLORREF backgroundColor;
	COLORREF darkBevelColor;
	COLORREF lightBevelColor;
};

#endif // !defined(AFX_TASKBARTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_)
